Mam na Debianie apacha2 php5 i mysql, gdy działało wszystko w normalnym środowisko to żadnego problemu nie było.
Gdy uruchamiam w jailu to wyskakuje mi w przeglądarce taki błąd (na maszynie jak wchodzę i jak z innego komputera).
To jest plik index.php (przykładowy gdzieś znaleziony - działał bez problemu):
Kod: Zaznacz cały
<?php
print 'test - php działa
';
// polaczenie z baza danych
if (!($connection = mysql_connect('localhost', 'uzytkownik', 'haslo')))
die('Nie mozna nawiazac polaczenia');
// wybieramy baze danych
if (!(mysql_select_db('test', $connection))) die('Nie mozna wybrac bazy');
// tworzymy tabele
if (!(mysql_query('CREATE TABLE pierwsza (
tekst varchar(100)
)
'))) die('Nie mozna stworzyc tabeli');
print 'tabela stworzona
';
// usuniecie tabeli
if (!(mysql_query('DROP TABLE pierwsza'))) die('nie mozna usunac tabeli');
print 'tabela usunieta';
?>
Kod: Zaznacz cały
Fatal error: Call to undefined function mysql_connect() in /var/www/idex.php on line 5
[Dodane: 2009-05-06, 23:16]
Witam.
Ozłocę dosłownie kogoś kto znajdzie mi rozwiązanie problemu, z którym się już borykam od kilku dobrych dni.
Zrobiłem ręcznie jaila dla apacha2 w katalogu /chroot/apache.
Teraz odpalam go za pomocą komendy:
Kod: Zaznacz cały
chroot /chroot/apache/ /usr/sbin/apache2
Po prostu z linii jak normalnego
Kod: Zaznacz cały
/etc/init.d/apache2 restart
Szperam w internecie to na przykład jak edytować teraźniejszy plik jaki mam nic nie znalazłem?
A wygląda on tak:
Kod: Zaznacz cały
#!/bin/sh -e
### BEGIN INIT INFO
# Provides: apache2
# Required-Start: $local_fs $remote_fs $network $syslog
# Required-Stop: $local_fs $remote_fs $network $syslog
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Start/stop apache2 web server
### END INIT INFO
#
# apache2 This init.d script is used to start apache2.
# It basically just calls apache2ctl.
ENV="env -i LANG=C PATH=/usr/local/bin:/usr/bin:/bin"
#[ `ls -1 /etc/apache2/sites-enabled/ | wc -l | sed -e 's/ *//;'` -eq 0 ] && \
#echo "You haven't enabled any sites yet, so I'm not starting apache2." && \
#echo "To add and enable a host, use addhost and enhost." && exit 0
#edit /etc/default/apache2 to change this.
HTCACHECLEAN_RUN=auto
HTCACHECLEAN_MODE=daemon
HTCACHECLEAN_SIZE=300M
HTCACHECLEAN_DAEMON_INTERVAL=120
HTCACHECLEAN_PATH=/var/cache/apache2/mod_disk_cache
HTCACHECLEAN_OPTIONS=""
set -e
if [ -x /usr/sbin/apache2 ] ; then
HAVE_APACHE2=1
else
echo "No apache MPM package installed"
exit 0
fi
. /lib/lsb/init-functions
test -f /etc/default/rcS && . /etc/default/rcS
test -f /etc/default/apache2 && . /etc/default/apache2
APACHE2CTL="$ENV /usr/sbin/apache2ctl"
HTCACHECLEAN="$ENV /usr/sbin/htcacheclean"
PIDFILE=`. /etc/apache2/envvars ; echo $APACHE_PID_FILE`
if [ -z "$PIDFILE" ] ; then
echo ERROR: APACHE_PID_FILE needs to be defined in /etc/apache2/envvars >&2
exit 2
fi
check_htcacheclean() {
[ "$HTCACHECLEAN_MODE" = "daemon" ] || return 1
[ "$HTCACHECLEAN_RUN" = "yes" ] && return 0
[ "$HTCACHECLEAN_RUN" = "auto" \
-a -e /etc/apache2/mods-enabled/disk_cache.load ] && return 0
return 1
}
start_htcacheclean() {
$HTCACHECLEAN $HTCACHECLEAN_OPTIONS -d$HTCACHECLEAN_DAEMON_INTERVAL \
-i -p$HTCACHECLEAN_PATH -l$HTCACHECLEAN_SIZE
}
stop_htcacheclean() {
killall htcacheclean 2> /dev/null || echo ...not running
}
pidof_apache() {
# if pidof is null for some reasons the script exits automagically
# classified as good/unknown feature
PIDS=`pidof apache2` || true
[ -e $PIDFILE ] && PIDS2=`cat $PIDFILE`
# if there is a pid we need to verify that belongs to apache2
# for real
for i in $PIDS; do
if [ "$i" = "$PIDS2" ]; then
# in this case the pid stored in the
# pidfile matches one of the pidof apache
# so a simple kill will make it
echo $i
return 0
fi
done
return 1
}
apache_stop() {
if `$APACHE2CTL configtest > /dev/null 2>&1`; then
# if the config is ok than we just stop normaly
$APACHE2CTL stop 2>&1 | grep -v 'not running' >&2 || true
else
# if we are here something is broken and we need to try
# to exit as nice and clean as possible
PID=$(pidof_apache)
if [ "${PID}" ]; then
# in this case it is everything nice and dandy
# and we kill apache2
log_warning_msg "We failed to correctly shutdown apache, so we're now killing all running apache processes. This is almost certainly suboptimal, so please make sure your system is working as you'd expect now!"
kill $PID
elif [ "$(pidof apache2)" ]; then
if [ "$VERBOSE" != no ]; then
echo " ... failed!"
echo "You may still have some apache2 processes running. There are"
echo "processes named 'apache2' which do not match your pid file,"
echo "and in the name of safety, we've left them alone. Please review"
echo "the situation by hand."
fi
return 1
fi
fi
}
apache_wait_stop() {
# running ?
PIDTMP=$(pidof_apache)
if $(kill -0 "${PIDTMP:-}" 2> /dev/null); then
PID=$PIDTMP
fi
apache_stop
# wait until really stopped
if [ -n "${PID:-}" ]; then
i=0
while $(kill -0 "${PID:-}" 2> /dev/null); do
if [ $i = '60' ]; then
break;
else
if [ $i = '0' ]; then
echo -n " ... waiting "
else
echo -n "."
fi
i=$(($i+1))
sleep 1
fi
done
fi
}
case $1 in
start)
log_daemon_msg "Starting web server" "apache2"
if $APACHE2CTL start; then
if check_htcacheclean ; then
log_progress_msg htcacheclean
start_htcacheclean || log_end_msg 1
fi
log_end_msg 0
else
log_end_msg 1
fi
;;
stop)
if check_htcacheclean ; then
log_daemon_msg "Stopping web server" "htcacheclean"
stop_htcacheclean
log_progress_msg "apache2"
else
log_daemon_msg "Stopping web server" "apache2"
fi
if apache_wait_stop; then
log_end_msg 0
else
log_end_msg 1
fi
;;
reload | force-reload)
if ! $APACHE2CTL configtest > /dev/null 2>&1; then
$APACHE2CTL configtest || true
log_end_msg 1
exit 1
fi
log_daemon_msg "Reloading web server config" "apache2"
if pidof_apache > /dev/null ; then
if $APACHE2CTL graceful $2 ; then
log_end_msg 0
else
log_end_msg 1
fi
fi
;;
restart)
if check_htcacheclean ; then
log_daemon_msg "Restarting web server" "htcacheclean"
stop_htcacheclean
log_progress_msg apache2
else
log_daemon_msg "Restarting web server" "apache2"
fi
PID=$(pidof_apache) || true
if ! apache_wait_stop; then
log_end_msg 1 || true
fi
if $APACHE2CTL start; then
if check_htcacheclean ; then
start_htcacheclean || log_end_msg 1
fi
log_end_msg 0
else
log_end_msg 1
fi
;;
start-htcacheclean)
log_daemon_msg "Starting htcacheclean"
start_htcacheclean || log_end_msg 1
log_end_msg 0
;;
stop-htcacheclean)
log_daemon_msg "Stopping htcacheclean"
stop_htcacheclean
log_end_msg 0
;;
status)
PID=$(pidof_apache)
if [ -n "$PID" ]; then
log_success_msg "Apache is running (pid $PID)."
exit 0
else
log_failure_msg "Apache is not running."
exit 1
fi
;;
*)
log_success_msg "Usage: /etc/init.d/apache2 {start|stop|restart|reload|force-reload|start-htcacheclean|stop-htcacheclean|status}"
exit 1
;;
esac
Kod: Zaznacz cały
#! /bin/bash
#
# apache Start the apache HTTP server.
#
CHRDIR=/chroot/apache
NAME=apache2
PATH=/bin:/usr/bin:/sbin:/usr/sbin
DAEMON=/usr/sbin/apache2
SUEXEC=/usr/lib/apache2/modules/mod_suexec.so
PIDFILE=/var/run/$NAME.pid
CONF=/etc/apache2/apache2.conf
APACHECTL=/usr/sbin/apache2ctl
trap "" 1
export LANG=C
export PATH
test -f $DAEMON || exit 0
test -f $APACHECTL || exit 0
# ensure we don't leak environment vars into apachectl
APACHECTL="env -i LANG=${LANG} PATH=${PATH} chroot $CHRDIR $APACHECTL"
if egrep -q -i "^[[:space:]]*ServerType[[:space:]]+inet" $CONF
then
exit 0
fi
case "$1" in
start)
echo -n "Starting web server: $NAME"
mount -t proc proc /chroot/apache/proc
start-stop-daemon --start --pidfile $PIDFILE --exec $DAEMON \
--chroot $CHRDIR
;;
stop)
echo -n "Stopping web server: $NAME"
start-stop-daemon --stop --pidfile "$CHRDIR/$PIDFILE" --oknodo
umount /chroot/apache/proc
;;
reload)
echo -n "Reloading $NAME configuration"
start-stop-daemon --stop --pidfile "$CHRDIR/$PIDFILE" \
--signal USR1 --startas $DAEMON --chroot $CHRDIR
;;
reload-modules)
echo -n "Reloading $NAME modules"
start-stop-daemon --stop --pidfile "$CHRDIR/$PIDFILE" --oknodo \
--retry 30
start-stop-daemon --start --pidfile $PIDFILE \
--exec $DAEMON --chroot $CHRDIR
;;
restart)
$0 reload-modules
exit $?
;;
force-reload)
$0 reload-modules
exit $?
;;
*)
echo "Usage: /etc/init.d/$NAME {start|stop|reload|reload-modules|force-reload|restart}"
exit 1
;;
esac
if [ $? == 0 ]; then
echo .
exit 0
else
echo failed
exit 1
fi
Kod: Zaznacz cały
/etc/init.d/apache2 start
Kod: Zaznacz cały
/etc/init.d/apache2 start
: command not found: line 5:
: command not found: line 7:
: command not found: line 14:
: command not found: line 15:
: invalid signal specificationtrap: 1
':not a valid identifier 18: export: 'PATH
:command not found: line 19:
: numeric argument required0: exit: 0
Pozdrawiam.